import es, gamethread, playerlib, usermsg
from random import randint

freeze_radius = es.ServerVar("freeze_radius")
freeze_damage = es.ServerVar("freeze_damage")
freeze_invulnerable = es.ServerVar("freeze_invulnerable")
freeze_duration = es.ServerVar("freeze_duration")
freeze_turning = es.ServerVar("freeze_turning")
freeze_trail = es.ServerVar("freeze_trail")
freeze_effect = es.ServerVar("freeze_effect")

def load():
    if freeze_damage != 100 or freeze_radius != 350:
        es.doblock('corelib/noisy_on')

def es_map_start(ev):
    es.stringtable('downloadables', "sound/frostnade/impalehit.wav")
    es.stringtable('downloadables', "sound/frostnade/impalelaunch1.wav")
    es.stringtable('downloadables', "materials/overlays/hns/icetexture.vmt")
    es.stringtable('downloadables', "materials/overlays/hns/icetexture.vtf")
    
def weapon_fire(event_var):
    """
    Calls modify_hegrenade in 0.1 seconds if necessary
    """
    if event_var['weapon'] == 'hegrenade':
        gamethread.delayed(0.3, modify_hegrenade, event_var['userid'])
        
def player_hurt(ev):
    if freeze_duration > 0:
        if ev["weapon"] == "hegrenade" and ev["es_userteam"] != ev["es_attackerteam"]:
            uid = ev["userid"]
            libplayer = playerlib.getPlayer(uid)
            
            libplayer.setSpeed(0)
            libplayer.setColor(0, 150, 255,255)
            
            es.server.queuecmd("es_cexec %s r_screenoverlay \"overlays/hns/icetexture\"" % uid)
            
            # usermsg.fade(uid,2, freeze_duration*300, freeze_duration*300, 160, 160, 200, 80)
            gamethread.cancelDelayed(str(uid))
            #
            gamethread.delayedname(freeze_duration*0.285, str(uid), es.emitsound,('player', uid, "frostnade/impalehit.wav", 1.0, 0.5) )
            gamethread.delayedname(freeze_duration*0.714, str(uid), prefreeze, libplayer)
            gamethread.delayedname(freeze_duration, str(uid), unfreeze, libplayer)
            if freeze_invulnerable:
                libplayer.godmode(1)
                
            if not freeze_turning:
                es.setplayerprop(libplayer, "CBasePlayer.m_fFlags", 64)
                


def modify_hegrenade(str_userid):
    """Modifies the damage and radius properties of any hegrenade belonging to str_userid"""
    dict_entity_list = es.createentityindexlist('hegrenade_projectile')
    str_player_handle = es.getplayerhandle(str_userid)

    for int_index in dict_entity_list:
        if str_player_handle == es.getindexprop(int_index, 'CBaseEntity.m_hOwnerEntity'):
            es.setindexprop(int_index, 'CBaseGrenade.m_flDamage', freeze_damage)
            es.setindexprop(int_index, 'CBaseGrenade.m_DmgRadius', freeze_radius)
            es.setindexprop(int_index, "CBaseEntity.m_clrRender", setcolor(0,0,255))
            es.setindexprop(int_index, "CBaseEntity.m_nRenderMode", es.getindexprop(int_index, "CBaseEntity.m_nRenderMode") | 1)
            es.setindexprop(int_index, "CBaseEntity.m_nRenderFX", es.getindexprop(int_index, "CBaseEntity.m_nRenderFX") | 256)
            if freeze_trail:
                createParentedStack(int_index)
            return

def prefreeze(libplayer):
    es.server.queuecmd('es_cexec %s r_screenoverlay 0' % libplayer)
    es.emitsound('player', int(libplayer), "frostnade/impalelaunch1.wav", 1.0, 0.5)
    if not freeze_turning:
        es.setplayerprop(int(libplayer),"CBasePlayer.m_fFlags", 1)
    libplayer.setSpeed(0.7)
    if freeze_effect:
        createShards(int(libplayer))
    
            
def createParentedStack(index):
    coords = es.getindexprop(index ,"CBaseEntity.m_vecOrigin")
    es.setentityname(index, "he_%s" % index)
    
    index2 = es.createentity("env_smokestack","smokst")
    es.entitysetvalue(index2, "origin", coords.replace(","," "))
    es.entitysetvalue(index2, "smokematerial", "particle/snow")
    # es.entitysetvalue(index2, "smokematerial", "particle/SmokeStack.vmt")
    # es.entitysetvalue(index2, "parentname", "he_%s" % index)
    es.entitysetvalue(index2, "angles", "180 0 0")
    es.entitysetvalue(index2, "JetLength", 60)
    es.entitysetvalue(index2, "speed", 30)
    es.entitysetvalue(index2, "rate", 120)
    es.entitysetvalue(index2, "initialstate", 1)
    es.entitysetvalue(index2, "endsize", 0.1)
    es.entitysetvalue(index2, "startsize", 0.4)
    # es.entitysetvalue(index2, "twist", 60)
    # es.entitysetvalue(index2, "roll", 20)
    es.entitysetvalue(index2, "basespread", 20)
    es.entitysetvalue(index2, "spreadspeed", 20)
    
    es.entitysetvalue(index2, "renderamt", 255)
    es.entitysetvalue(index2, "rendercolor", "255 255 255")
    es.spawnentity(index2)
    es.server.queuecmd("es_fire %s smokst SetParent he_%s" % (es.getuserid(),index))
    es.server.queuecmd('es_fire %s smokst addoutput "OnUser1 !self,kill,-1,2.7"' % es.getuserid())
    # es.server.queuecmd('es_fire %s smokst addoutput "OnUser1 !self,addoutput,rate 0,1"' % es.getuserid())
    es.server.queuecmd('es_fire %s smokst addoutput "OnUser1 !self,ClearParent,-1,1.2"' % es.getuserid())
    es.server.queuecmd("es_fire %s smokst FireUser1" % es.getuserid())
            
            
def unfreeze(libplayer):
    if freeze_invulnerable:
        libplayer.godmode(0)
    libplayer.setSpeed(1)
    libplayer.setColor(255, 255, 255,255)
    
    
def setcolor(r,g,b):
    color = int(r) + (int(g) << 8) + (int(b) << 16)
    color += 255 << 24

    if color >= 2**31: color -= 2**32
    return color
    
def createShards(uid):
    coords = es.getplayerprop(uid ,"CBaseEntity.m_vecOrigin").split(",")
    for x in range(4):
        index = es.createentity("env_shooter","shooter")
        es.entitysetvalue(index, "angles", "90 0 0")
        es.entitysetvalue(index, "origin", "%s %s %s" % (coords[0],coords[1],float(coords[2])+48))
        raint = randint(1,5)
        es.precachemodel("models/gibs/glass_shard0%s.mdl" % raint)
        es.entitysetvalue(index, "shootmodel", "models/gibs/glass_shard0%s.mdl" % raint)
        es.entitysetvalue(index, "shootsounds", 0)
        es.entitysetvalue(index, "simulation", 0)
        es.entitysetvalue(index, "gibanglevelocity", 100)
        es.entitysetvalue(index, "m_flVariance", 30)
        es.entitysetvalue(index, "m_flVelocity", 400)
        es.entitysetvalue(index, "m_iGibs", 6)
        es.entitysetvalue(index, "m_flGibLife", 4)
        es.entitysetvalue(index, "gibangles", "0 0 90")
        es.entitysetvalue(index, "spawnflags", 4)
        
        es.spawnentity(index)
    
    es.server.queuecmd("es_fire %s shooter Shoot" % uid)
    
    es.server.queuecmd('es_fire %s shooter addoutput "OnUser1 !self,kill,-1,10"' % uid)
    es.server.queuecmd("es_fire %s shooter FireUser1" % uid)
